// Preklapanje operatora ->.

#include <iostream>
using namespace std;

#include <iostream>
using namespace std;

struct Obj { double x, y; };  // Korisceni objekat.

class Broji {                 // "Pametan" pokazivac: broji pristupe.
  Obj* p;                     // Pokazivac na pridruzeni objekat.
  int n;                      // Broj pristupa pridruzenom objektu.
public:
  Broji (Obj* po): n(0), p(po) {}       // Inicijalizacija.
  Obj* operator->() { n++; return  p; } // Pristup clanu.
  Obj& operator* () { n++; return *p; } // Pristup objektu.
  int operator+() const { return n; }   // Broj pristupa.
} ;

class Pise {                  // "Pametan" pokazivac: pise broj pristupa.
  Broji* p;                   // Pokazivac na pridruzeni objekat.
public:
  Pise(Broji* pb): p(pb) {}             // Inicijalizacija.
  Broji& operator->()                   // Pristup clanu.
    { cout << +*p; return *p; }
};

int main () {
  Obj a= {1, 2};
  Broji broji(&a);            // "Pametan" pokazivac: broji pristupe.
  broji->x = broji->y = 0;
  cout << +broji << endl;     // Pise se: 2
  Obj b = *broji;
  cout << +broji << endl;     // Pise se: 3

  Obj* pb = &b;               // "Obican" pokazivac.
  pb->x = pb->y = 5;
  *broji = *pb;
  cout << +broji << endl;     // Pise se: 4

  Pise pise(&broji);          // "Pametan" pokazivac: pise broj pristupa.
  pise->x = 1; cout << endl;  // Pise se: 4
  cout << +broji << endl;     // Pise se: 5
}

