// Ispitivanje genericke klase za uredjivanje nizova podataka.

#include "uredi.h"
#include "opada.h"
#include "tacka3.h"
#include "pravoug1.h"
#include <iostream>
using namespace std;

template<typename S>
  void radi(const char* naslov) {
    cout << "\n" << naslov << "\n\n";
    int n; cin >> n; S* a = new S [n];
    cout << "Pocetni   niz:";
    for (int i=0;i<n;i++) { cin>>a[i]; cout<<' '<<a[i]; } cout<<endl;
    Uredi<S>::uredi(a, n);
    cout << "Rastuci   niz:";
    for (int i=0; i<n; i++) cout << ' ' << a[i]; cout << endl;
    Uredi<S,Opada<S>>::uredi(a, n);
    cout << "Opadajuci niz:";
    for (int i=0; i<n; i++) cout << ' ' << a[i]; cout << endl;
    delete [] a;
  }

int main() {
  radi<int>    ("Uredjivanje niza celih brojeva:");
  radi<Tacka>  ("Uredjivanje niza tacaka:");
  radi<Pravoug>("Uredjivanje niza pravougaonika:");
}

